export default class DropdownMenuHandler{

    constructor(menuButtonId,menuItemsContainerId,cssClass2Show){

        this.menuButtonId =menuButtonId;
        this.menuItemsContainerId =menuItemsContainerId;
        this.cssClass2Show =cssClass2Show;

        document.addEventListener("click",
            (event) => this.resolveOutOfMenuClick(event));

        document.getElementById(this.menuButtonId).addEventListener("click",
            () => this.displayOrHideMenu());

    }

    displayOrHideMenu(){
        document.getElementById(this.menuItemsContainerId).classList.toggle(this.cssClass2Show);
    }

    resolveOutOfMenuClick(event){
        if(!event.target.matches(`#${this.menuButtonId}`)) this.hideMenu();
    }

    hideMenu() {
        let menuClElmCList=document.getElementById(this.menuItemsContainerId).classList;
        if(menuClElmCList.contains(this.cssClass2Show)) menuClElmCList.remove(this.cssClass2Show);

    }

}






