export default class OpinionHandler{

    constructor(newOpinionFormId){

        this.newOpinionFormId =newOpinionFormId;

    }

    get back4appUrl(){
        return "https://parseapi.back4app.com/classes/opinions";
    }

    get back4appHeaders(){
        return {
            "X-Parse-Application-Id": "ygvQv5SiQusJl5Ba5QIB6IFstE716eRGK3lfBOgy",
            "X-Parse-REST-API-Key": "S7scxlRO6lBd4UECAIx2u9bvCyxGmjuADQvFOLSY"
        };
    }

    processOpnFrmData(event){
        event.preventDefault();

        const formElements = document.getElementById(this.newOpinionFormId).elements;

        const newOpinion =
            {
                name: formElements['login'].value.trim(),
                comment: formElements['comment'].value.trim(),
                willReturn: formElements['willReturn'].checked
            };

        if(newOpinion.name=="" || newOpinion.comment==""){
            window.alert("Please, enter both your name and opinion");
            return;
        }

        console.log(newOpinion);

        const reqHeaders=this.back4appHeaders;
        reqHeaders["Content-Type"]="application/json";


        const init={
            headers: reqHeaders,
            method: 'POST',
            body: JSON.stringify(newOpinion)
        }

        console.log(init);

        fetch(window.opHandler.back4appUrl,init)
            .then(response =>{      //fetch promise fullfilled (operation completed successfully)
                if(response.ok){    //successful execution includes an error response from the server. So we have to check the return status of the response here.
                    return response.json(); //we return a new promise with  the response data in JSON to be processed
                }else{ //if we get server error
                    return Promise.reject(new Error(`Server answered with ${response.status}: ${response.statusText}.`)); //we return a rejected promise to be catched later
                }
            })
            .then(responseJSON => { //here we process the returned response data in JSON ...
                console.log(`Opinion added at ${responseJSON.createdAt} with id=${responseJSON.objectId}. `);
                window.alert('Your opinion has been saved');
                window.location.hash="#opinions";
            })
            .catch (error => { ////here we process all the failed promises
                window.alert(`Failed to save your opinion: ${error}`);
            });
    }


}






